#ifndef __REALM_HEADER_INCLUDED__
#define __REALM_HEADER_INCLUDED__

typedef void (*proc_realm_match)(struct packet *, unsigned int);
typedef int (*proc_realm_commit)(struct rule*);

struct realm {
	struct realm		*next;

	const char		*name;

	unsigned int		mask;

	/* Preprocessors */
	struct pp_active	*preproc;
	unsigned int		num_active;
	unsigned int		max_active;

	/* Signature subsystem */
	proc_realm_match	match;
	proc_realm_commit	commit;

};

#ifndef __PLUGIN__
void realm_init(void);
void realm_cleanup(int, void *);
#endif

#ifndef __PLUGIN__
struct realm *realm_add(const char *, proc_realm_match, proc_realm_commit);
struct realm *realm_add2(const char *, proc_realm_match, proc_realm_commit);
struct realm *realm_find(char *);
#else
typedef struct realm *(*proc_realm_add)(const char *, proc_realm_match, proc_realm_commit);
typedef struct realm *(*proc_realm_find)(char *);
#endif

#endif /* __REALM_HEADER_INCLUDED__ */
